<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: AccessoriesCircularBuffer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classAccessoriesCircularBuffer.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classAccessoriesCircularBuffer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">AccessoriesCircularBuffer Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="AccessoriesCircularBuffer_8hpp_source.html">AccessoriesCircularBuffer.hpp</a>&quot;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7f1b78c04534046538cca20d3859e510"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessoriesCircularBuffer.html#a7f1b78c04534046538cca20d3859e510">AccessoriesCircularBuffer</a> ()</td></tr>
<tr class="separator:a7f1b78c04534046538cca20d3859e510"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8c081c387cb554e9f4f4808199b69cf"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessoriesCircularBuffer.html#ac8c081c387cb554e9f4f4808199b69cf">begin</a> (int inStartListPos, byte inItemSize, byte inReplicaNumber)</td></tr>
<tr class="separator:ac8c081c387cb554e9f4f4808199b69cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a549a4c48972a76eb85cfb9d9a5457e73"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessoriesCircularBuffer.html#a549a4c48972a76eb85cfb9d9a5457e73">getStartRead</a> ()</td></tr>
<tr class="separator:a549a4c48972a76eb85cfb9d9a5457e73"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a439491385ea8825a2a2405ba9db109b5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessoriesCircularBuffer.html#a439491385ea8825a2a2405ba9db109b5">startWrite</a> ()</td></tr>
<tr class="separator:a439491385ea8825a2a2405ba9db109b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a429a5a2adc4299a766469177f6a772b6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAccessoriesCircularBuffer.html#a429a5a2adc4299a766469177f6a772b6">clear</a> () const </td></tr>
<tr class="separator:a429a5a2adc4299a766469177f6a772b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements the Atmel solution to avoid writing in EEPROM always in the same area to improve lifetime of this memory : a Circular Buffer. See <a href="http://www.atmel.com/images/doc2526.pdf">http://www.atmel.com/images/doc2526.pdf</a> . Part of the pdf file :</p>
<blockquote class="doxtable">
<p>By having a circular buffer (O-buffer) in EEPROM it is possible to increase the number of times that a parameter can be stored in EEPROM. If the buffer has two levels the number of times that the parameter can be stored is twice the endurance of one single EEPROM cell: 200 k erase/writes. By using this approach it is possible to increase the number of times a parameter can be stored by increasing the O-buffer size. In other word, the idea is to distribute the storage of the parameter over several EEPROM locations to achieve increased parameter storage endurance. When using the Obuffer approach the parameter storage endurance equal the number of memory locations used in the O-buffer times the endurance of a single EEPROM location.</p>
</blockquote>
<p>A circular buffer is a way to reduce the use of each EEPROM cell, and improve life time of the full EEPROM memory. An index of bytes is stored at the beginning of the area. Each index represents a data area.</p>
<pre class="fragment">|0|1|2|3|4||---0---|---1---|---2---|---3---|---4---|
</pre> 
<p class="definition">Definition at line <a class="el" href="AccessoriesCircularBuffer_8hpp_source.html#l00029">29</a> of file <a class="el" href="AccessoriesCircularBuffer_8hpp_source.html">AccessoriesCircularBuffer.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a7f1b78c04534046538cca20d3859e510"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">AccessoriesCircularBuffer::AccessoriesCircularBuffer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Basic constructor. </p>

<p class="definition">Definition at line <a class="el" href="AccessoriesCircularBuffer_8hpp_source.html#l00038">38</a> of file <a class="el" href="AccessoriesCircularBuffer_8hpp_source.html">AccessoriesCircularBuffer.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ac8c081c387cb554e9f4f4808199b69cf"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int AccessoriesCircularBuffer::begin </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inStartListPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">byte&#160;</td>
          <td class="paramname"><em>inItemSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">byte&#160;</td>
          <td class="paramname"><em>inReplicaNumber</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Initialize the instance. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inStartListPos</td><td>EEPROM address of the begginning of the memory used for the storage </td></tr>
    <tr><td class="paramname">inItemSize</td><td>Size in bytes of one item to save. </td></tr>
    <tr><td class="paramname">inReplicaNumber</td><td>Number of copies of the element can be reserved for the buffer. 2 is a minimum, 255 a maximum. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Number of EEPROM bytes reserved for the circular buffer. </dd></dl>

<p class="definition">Definition at line <a class="el" href="AccessoriesCircularBuffer_8hpp_source.html#l00046">46</a> of file <a class="el" href="AccessoriesCircularBuffer_8hpp_source.html">AccessoriesCircularBuffer.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a429a5a2adc4299a766469177f6a772b6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void AccessoriesCircularBuffer::clear </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Fill with 0s the area reserved for the buffer. Use with care ! </p>

</div>
</div>
<a class="anchor" id="a549a4c48972a76eb85cfb9d9a5457e73"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int AccessoriesCircularBuffer::getStartRead </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>If data cannot be loaded with a single call to a 'read', this function can be called to know where to read the current good element. </p><dl class="section return"><dt>Returns</dt><dd>EEPROM address to start reading data. </dd></dl>

</div>
</div>
<a class="anchor" id="a439491385ea8825a2a2405ba9db109b5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int AccessoriesCircularBuffer::startWrite </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>If data cannot be stored with a single call to a 'write', this function can be called to prepare the saving of the next good element. </p><dl class="section return"><dt>Returns</dt><dd>EEPROM address to start writing data. Be careful, do not store more bytes than the inElementSize given during <a class="el" href="classAccessoriesCircularBuffer.html#ac8c081c387cb554e9f4f4808199b69cf">begin()</a> call ! </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="AccessoriesCircularBuffer_8hpp_source.html">AccessoriesCircularBuffer.hpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classAccessoriesCircularBuffer.html">AccessoriesCircularBuffer</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
